import bpy,math,os,sys

from bpy.types import NodeTree, Node,NodeSocket
from bpy.props import*
from mathutils import*


from .IMDJS_tree import 卐颜色接口卐NodeSocket,卐IMDJS_nodes,卐IMDJS_NODES,卐IMDJS_NODES_PSR ;
#from ..function_node import *

from ..operator_node import *;


#///////////////////////////////////////////////////

class 卐获得float卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodeGetFloat'
    bl_label = 'get float'
    #bl_icon = 'FORCE_VORTEX'

    sp节点类型 = StringProperty()
    sp属性 = StringProperty()
    bp使用自己 = BoolProperty()
    Object = StringProperty()

    def init(self, context):
        self.b使用回放颜色 = True
        self.sp节点类型 = "BREAK"

        self.outputs.new("NodeSocketFloatFactor","FLOAT")

    # Atualiza o valor do 下一个 com o valor Absoluto
    def Δ升级节点(self):
        if( self.bp是禁用节点):return ;
        scene = bpy.context.scene
        if not self.bp使用自己:
            Object = bpy.context.scene.objects[self.Object]
        else:
            Object = bpy.context.scene.objects[bpy.context.scene.pp场景物体MT设定s2.sp物名]

        # UPDATE
        self.outputs["FLOAT"].default_value = 属ΔΔ获得属性(Object,self.sp属性)

    # Additional buttons displayed on the node.
    def draw_buttons(self, context, layout):
        row = layout.row(True)
        row.prop(self, "bp使用自己", text = "Self")
        if not self.bp使用自己:
            row.prop_search(self, "Object",  context.scene, "objects", text="")
        layout.prop(self, "sp属性", text = "sp属性")

    # Detail buttons in the sidebar.
    def draw_buttons_ext(self, context, layout):
        row = layout.row(True)
        row.prop(self, "bp使用自己", text = "Self")
        if not self.bp使用自己:
            row.prop_search(self, "Object",  context.scene, "objects", text="")
        layout.prop(self, "sp属性", text = "sp属性")

#////////////////////////////////////////////////
class 卐获得vector卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodeGetVector'
    bl_label = '获得vector'
    #bl_icon = 'FORCE_VORTEX'

    
    sp属性 = StringProperty();
    bp使用自己 = BoolProperty();
    Object = StringProperty();

    def init(self, context):
        self.b使用回放颜色 = True
        self.sp节点类型 = "BREAK"

        self.outputs.new("NodeSocketVector","VECTOR");

    # Atualiza o valor do 下一个 com o valor Absoluto
    def Δ升级节点(self):
        if not self.bp使用自己:
            Object = bpy.context.scene.objects[self.Object];
        else:
            Object = bpy.context.scene.objects[bpy.context.scene.pp场景物体MT设定s2.sp物名];

        # UPDATE
        self.outputs["VECTOR"].default_value = 属ΔΔ获得属性(Object,self.sp属性);
        

    def draw_buttons(self, context, layout):
        row = layout.row(True);
        row.prop(self, "bp使用自己", text = "Self");
        if not self.bp使用自己:
            row.prop_search(self, "Object",  context.scene, "objects", text="");
        layout.prop(self, "sp属性", text = "sp属性");

    # Detail buttons in the sidebar.
    def draw_buttons_ext(self, context, layout):
        row = layout.row(True);
        row.prop(self, "bp使用自己", text = "Self");
        if not self.bp使用自己:
            row.prop_search(self, "Object",  context.scene, "objects", text="");
        layout.prop(self, "sp属性", text = "sp属性");

#////mt_nodes_inputs.py/////////////////////////////////////////////////////
# INPUT NODES ------------------------------------------------------------------
class 卐获得物体PSR卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeGetObject"
    bl_label = "get object PSR"
    bl_icon = "SOUND"

    sp节点类型 = StringProperty()
    Self = BoolProperty()
    Object = StringProperty()
    World = BoolProperty()

    def init(self,context):
        self.sp节点类型 = "BREAK"
        self.outputs.new("NodeSocketVectorTranslation","P")
        self.outputs.new("NodeSocketVectorXYZ","S")
        self.outputs.new("NodeSocketVectorXYZ","R")

    def Δ升级节点(self):
        if( self.bp是禁用节点):return ;
        Target = None;
        if (self.Self):
            Target = bpy.context.scene.objects[bpy.context.scene.pp场景物体MT设定s2.sp物名];
        else:
            Target = bpy.context.scene.objects[self.Object];

        if (len(self.outputs["P"].links) > 0):
            if (self.World):
                o = Target;
                loc = o.matrix_world.to_translation();
                self.outputs["P"].default_value = loc;
            else:
                self.outputs["P"].default_value = Target.location;

        if (len(self.outputs["S"].links) > 0):
            if (self.World):
                o = Target;
                sca = o.matrix_world.to_scale();
                sa = sca[0],sca[1],sca[2];
                sb = Target.scale;
                a = [(sa[0] * sb[0]),(sa[1] * sb[1]),(sa[2] * sb[2])];
                self.outputs["S"].default_value = a;
            else:
                self.outputs["S"].default_value = Target.scale;

        if (len(self.outputs["R"].links) > 0):
            o = Target ;

            if (self.World):
                loc,rot,sca = o.matrix_world.decompose();
                rotW = rot * o.rotation_euler.to_matrix().to_quaternion();
                rot1 = rotW.to_euler("NodeSocketVectorXYZ");

                rot =   [math.degrees(rot1[0]),math.degrees(rot1[1]),math.degrees(rot1[2])];
            else:
                rot =   [math.degrees(o.rotation_euler[0]),math.degrees(o.rotation_euler[1]),math.degrees(o.rotation_euler[2])];
            self.outputs["R"].default_value = rot;

    # Additional buttons displayed on the node.
    def draw_buttons(self, context, layout):
        layout.prop(self,"Self", text = "Self");
        if (not self.Self):
            layout.prop_search(self, "Object",  context.scene, "objects", text="Object");

        layout.prop(self,"World", text = "World Coordinates");


class 卐影响范围卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeAreaInfluence"
    bl_label = "影响范围"
    bl_icon = "SOUND"

    PivotObject = StringProperty();
    Min = FloatProperty(min=0.0,max=1.0);
    Max = FloatProperty(min=0.0,max=1.0);
    x = FloatProperty();

    

    def init(self,context):
        self.sp节点类型 = "BREAK";
        self.outputs.new("NodeSocketFloatFactor","INFLUENCE");
        self.inputs.new("NodeSocketFloatFactor","DISTANCE");

    def Δ升级节点(self):
        if( self.bp是禁用节点):return ;
        Distance = self.inputs["DISTANCE"];
        if (len(Distance.links) > 0):
            n节点前面 = Distance.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            Distance.default_value = Distance.links[0].from_socket.default_value;

        # UPDATE
        if (len(self.outputs["INFLUENCE"].links) > 0):
            o = bpy.context.scene.objects[bpy.context.scene.pp场景物体MT设定s2.sp物名];
            piv = bpy.context.scene.objects[self.PivotObject];
            self.outputs["INFLUENCE"].default_value = ΔΔ范围影响(o,piv,self.inputs["DISTANCE"].default_value,self.Min,self.Max,self.x);

    def draw_buttons(self, context, layout):
        layout.prop_search(self, "PivotObject",  context.scene, "objects", text="Target");
        layout.prop(self,"Min");
        layout.prop(self,"Max");
        layout.prop(self,"×");

class 卐输出当前帧卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeGetFrame"
    bl_label = "输出当前帧"
    bl_icon = "SOUND"

    

    def init(self,context):
        self.sp节点类型 = "BREAK";
        self.outputs.new("NodeSocketFloatFactor","OUTPUT");

    def Δ升级节点(self):
        if( self.bp是禁用节点):return ;
        #print("FRAME==",bpy.context.G.Li当前帧GG[0]);
        self.outputs["OUTPUT"].default_value = G.Li当前帧GG[0];

    def draw_buttons(self, context, layout):
        pass;


#======================================================
def 数ΔΔ生成随机数(a1,a2):
    if(str(type(a1)) in["<class 'float'>"] or str(type(a2)) in["<class 'float'>"]):
        数 = random.uniform(a1,a2);#将随机生成下一个实数，它在[x,y]范围内。
    else:
        数 = random.randint(a1,a2);
    return 数;

class 卐输出随机数卐IMDJS_NODES(Node,卐IMDJS_NODES):
    ''' Get a Object Parameters '''
    bl_idname = "IMDJS_NodeOutputRandom"
    bl_label = "ramdom output"
    bl_icon = "SOUND"

    vp3=FloatVectorProperty(name="", description="", default=(0, 0, 0), min=-10000.0, max=10000.0, soft_min=-10000.0, soft_max=10000.0, step=1, options={'ANIMATABLE'}, subtype='NONE', size=3, update=None, get=None, set=None);
    #vp3=Vector();
    
    ep类型 = EnumProperty( name="type", description="输出数据类型",items=  [("FLOAT","FLOAT","---","FONT_DATA",0),#(identifier, name, description, icon, number)
                                                                                               ("VECTOR", "VECTOR","---.","MANIPUL",1)  ],default="FLOAT");
    ip种子 = IntProperty();
    A = FloatProperty();
    B = FloatProperty();

    def init(self,context):
        self.sp节点类型 = "BREAK";
        self.outputs.new("NodeSocketFloatFactor","OUTPUT_FLOAT");
        self.outputs.new("NodeSocketVectorXYZ","OUTPUT_VECTOR");
    def Δ升级节点(self):
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        s物名 = bpy.context.scene.pp场景物体MT设定s2.sp物名;
        if(self.ep类型=="FLOAT"):
            self.outputs["OUTPUT_FLOAT"].default_value =数ΔΔ生成随机数(self.A,self.B);
        else:
            self.vp3[0]=数ΔΔ生成随机数(self.A,self.B);
            self.vp3[1]=数ΔΔ生成随机数(self.A,self.B);
            self.vp3[2]=数ΔΔ生成随机数(self.A,self.B);
            #print("vp3==",self.vp3[0],self.vp3[1],self.vp3[2]);
            self.outputs["OUTPUT_VECTOR"].default_value =self.vp3;

    def draw_buttons(self, context, layout):
        layout.prop(self, 'ep类型',  text = "type",emboss=True); #下拉菜单
        layout.prop(self,"ip种子");
        layout.prop(self,"A");
        layout.prop(self,"B");


#//////////////////////////////////////////////////
class 卐输入显示卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeShowIntput"
    bl_label = "输入显示"
    bl_icon = "SOUND"

    fp显示= FloatProperty(name="浮点显示",default=0.0);
    ip显示= FloatProperty(name="整数显示",default=0);
    fvp3显示=FloatVectorProperty(name='乛显示',description='',default=(0.0,0.0,0.0),min=-10000.0,max=10000.0,soft_min=-10000.0,soft_max=10000.0,step=3,precision=2,subtype='NONE',unit='NONE',size=3,);

    #==============================================================
    def init(self,context):
        self.sp节点类型 = "BREAK";
        self.use_custom_color=True;
        self.inputs.new("NodeSocketFloatFactor","INPUT_FLOAT");
        self.inputs.new("NodeSocketInt","INPUT_INT");
        self.inputs.new("NodeSocketVectorXYZ","INPUT_V_XYZ");
        self.width=200;

    #==============================================================
    def Δ升级节点(self):
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        ns输入浮点 = self.inputs["INPUT_FLOAT"];ns输入整数 = self.inputs["INPUT_INT"];ns输入乛 = self.inputs["INPUT_V_XYZ"];
        if (ns输入浮点.links):
            link=ns输入浮点.links[0];
            ns输入浮点.default_value = link.from_socket.default_value;
            self.fp显示= link.from_socket.default_value;
        if (ns输入整数.links):
            link=ns输入整数.links[0];
            ns输入整数.default_value = link.from_socket.default_value;
            self.ip显示= link.from_socket.default_value;
        if (ns输入乛.links):
            link=ns输入乛.links[0];
            ns输入乛.default_value = link.from_socket.default_value;
            self.fvp3显示= link.from_socket.default_value;
            #self.fvp3显示[0]=20.3

    #==============================================================
    def draw_buttons(self, context, layout):
        layout.prop(self,"fp显示");
        layout.prop(self,"ip显示");
        layout.prop(self,"fvp3显示",slider=True);

                        
#////end////end////end////end////end////end////end////end////
                        
                        
                        